<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>登录页面</title>
 
    <link rel="stylesheet" type="text/css" href="css/login.css"/>
    <script src="http://libs.baidu.com/jquery/2.0.0/jquery.js"></script>
    <script src="http://www.gongjuji.net/Content/files/jquery.md5.js"></script>
</head>
 
<body>

<div id="user_frame">
    <img src="" id="headurl" alt="你没有头像，可以上传一个" height="100" width="100">
    <p>
        选择文件:
        <input type="file" id="ipt-file"/>
        <button type="button" id="btn_upload">上传</button>
    </p>
    <div class="progress-bar">
        <div class="progress"  id="progress"></div>
    </div>
    <p id="info"></p>

    <p><label class="label_input" style="display: inline-block;">用户名</label><input type="text" id="username" class="text_field" disabled="disabled" style="background-color: #D2CCCA;"/></p>
    <p><label class="label_input" style="display: inline-block;">昵称</label><input type="text" id="nickname" class="text_field"/></p>
    <div id="login_control">
        <input type="button" id="btn_edit" value="修改昵称"/>
        <input type="button" id="btn_logout" value="登出"/>
     </div>
</div>
 
</body>
</html>
<script>
    function getQueryVariable(variable) {
       var query = window.location.search.substring(1);
       var vars = query.split("&");
       for (var i=0;i<vars.length;i++) {
               var pair = vars[i].split("=");
               if(pair[0] == variable){return pair[1];}
       }
       return(false);
    }
    var button = document.querySelector("#btn_upload"),
    input = document.querySelector("#ipt-file"),
    progress = document.querySelector("#progress"),
    info = document.querySelector("#info");

    var headurl = document.getElementById('headurl')
    var username = document.getElementById('username')
    // from_username = getQueryVariable('name')
    userId = getQueryVariable('userId')
    // username.value = from_username
    username.setAttribute('readOnly', true)

    var xhr = new XMLHttpRequest();
    xhr.open('get', 'http://localhost:8080/user/' + userId);
    xhr.send()
    xhr.onreadystatechange = function () {
        if (xhr.readyState == 4 && xhr.status == 200) {
            console.log(xhr.responseText)
            var json = eval("("+xhr.responseText+")")

            if (json.Code != 0) {
                console.log(json.Msg)
                alert("请先登录!" + json.Msg)
                window.location.href = "http://localhost:8080/"
            }

            username.value = json.UserName
            nickname.value = json.NickName
            previousNickname = json.NickName

            if (json.ImageUrl != "") {
                console.log("set headurl:" + json.ImageUrl)
                headurl.src = json.ImageUrl
            }
        }
    }

    btn_logout.onclick = function() {
        var xhr = new XMLHttpRequest();
        xhr.open('post', 'http://localhost:8080/logout')
        xhr.setRequestHeader("Content-type","application/json")
        console.log(userId)
        var data = {"userId": parseInt(userId)}
        xhr.send(JSON.stringify(data));
        console.log("send to logout")
        xhr.onreadystatechange = function () {
            if (xhr.readyState == 4 && xhr.status == 200) {
                var json = eval("("+xhr.responseText+")");
                if (json.Code == 0) {
                    alert('登出成功!')
                    window.location.href = "http://localhost:8080/"
                } else {
                    alert("登出失败:" + json.Msg)
                }
            }
        }
    }

    btn_edit.onclick = function() {
        var newNickname = nickname.value
        if (newNickname.length < 1) {
            alert('昵称长度不能小于1')
            return
        }

        if (newNickname == previousNickname) {
            alert('昵称没有改变')
            return
        }

        var xhr = new XMLHttpRequest();
        xhr.open('put', 'http://localhost:8080/user/' + userId)
        xhr.setRequestHeader("Content-type","application/json")
        var data = {"nickname": newNickname}
        xhr.send(JSON.stringify(data));
        console.log("send to editnickname")
        xhr.onreadystatechange = function () {
            if (xhr.readyState == 4 && xhr.status == 200) {
                var json = eval("("+xhr.responseText+")");
                if (json.Code == 0) {
                    alert('修改成功')
                } else if (json.Code == 2) {
                    alert('没有权限，请登录')
                    window.location.href = "http://localhost:8080/"
                } else {
                    alert("修改失败:" + json.Msg)
                }
            }
        }
    }
    var upload = function() {

        if (input.files.length === 0) {
            console.log("未选择文件");
            return;
        }
	var formData = new FormData();
        formData.append("file", input.files[0]);
	var xhr = new XMLHttpRequest();

        xhr.onreadystatechange = function() {
            if (xhr.readyState === 4 && xhr.status === 200) {
                console.log(xhr.responseText);
                var json = eval("(" + xhr.responseText + ")");
                if (json.Code == 0 && json.ImageUrl != "") {
                    headurl.src = json.ImageUrl
                    alert("上传头像成功")
                } else {
                    alert("上传头像失败:" + json.Msg)
                }
            }
        };
	xhr.upload.addEventListener("progress", function(event) {
			if(event.lengthComputable){
			progress.style.width = Math.ceil(event.loaded * 100 / event.total) + "%";
			}
			}, false);

        xhr.open('put', 'http://localhost:8080/user/' + userId);
        // xhr.setRequestHeader("Content-type","multipart/form-data")
        // xhr.upload.onprogress = progressFunction;//【上传进度调用方法实现】
        // xhr.upload.onloadstart = function(){//上传开始执行方法
        //     ot = new Date().getTime();   //设置上传开始时间
        //     oloaded = 0;//设置上传开始时，以上传的文件大小为0
        // };
	xhr.send(formData);
    }

    button.addEventListener("click", upload, false);
    //上传成功响应
    function uploadComplete(evt) {
        //服务断接收完文件返回的结果

        var data = JSON.parse(evt.target.responseText);
        if(data.success) {
            alert("上传成功！");
        }else{
            alert("上传失败！");
        }

    }
    //上传失败
    function uploadFailed(evt) {
        alert("上传失败！");
    }
    //取消上传
    function cancleUploadFile(){
        xhr.abort();
    }


    //上传进度实现方法，上传过程中会频繁调用该方法
    function progressFunction(evt) {
        var progressBar = document.getElementById("progressBar");
        var percentageDiv = document.getElementById("percentage");
        // event.total是需要传输的总字节，event.loaded是已经传输的字节。如果event.lengthComputable不为真，则event.total等于0
        if (evt.lengthComputable) {//
            progressBar.max = evt.total;
            progressBar.value = evt.loaded;
            percentageDiv.innerHTML = Math.round(evt.loaded / evt.total * 100) + "%";
        }
        var time = document.getElementById("time");
        var nt = new Date().getTime();//获取当前时间
        var pertime = (nt-ot)/1000; //计算出上次调用该方法时到现在的时间差，单位为s
        ot = new Date().getTime(); //重新赋值时间，用于下次计算
        var perload = evt.loaded - oloaded; //计算该分段上传的文件大小，单位b
        oloaded = evt.loaded;//重新赋值已上传文件大小，用以下次计算
        //上传速度计算
        var speed = perload/pertime;//单位b/s
        var bspeed = speed;
        var units = 'b/s';//单位名称
        if(speed/1024>1){
            speed = speed/1024;
            units = 'k/s';
        }
        if(speed/1024>1){
            speed = speed/1024;
            units = 'M/s';
        }
        speed = speed.toFixed(1);
        //剩余时间
        var resttime = ((evt.total-evt.loaded)/bspeed).toFixed(1);
        time.innerHTML = '，速度：'+speed+units+'，剩余时间：'+resttime+'s';
        if(bspeed==0) time.innerHTML = '上传已取消';
    }
</script>

